Imports Microsoft.Win32

Public Class NumericTextBox
    Inherits Windows.Forms.TextBox

    Private Const C_REG_SUBKEY As String = "Software\Sharp\PhoneStatus"
    Private Const C_REG_KEY As String = "Status22"

    Private Const C_INPUTMODE_NUMERIC As Integer = 7

    Private mPrevInputMode As Integer = -1

    Public Sub New()
        'ŏɂƂ̒l擾Ă
        '(Ŏs΁AGot/LostFocusɂ͉ȂƂɂȂB)
        mPrevInputMode = GetInputMode()
    End Sub

    Private Sub NumericTextBox_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.GotFocus
        If mPrevInputMode >= 0 Then
            mPrevInputMode = SetInputMode(C_INPUTMODE_NUMERIC)
        End If
    End Sub

    Private Sub NumericTextBox_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.LostFocus
        If mPrevInputMode >= 0 Then
            SetInputMode(mPrevInputMode)
        End If
    End Sub

    Private Function SetInputMode(ByVal status As Integer) As Integer
        Dim subkey As RegistryKey = Nothing
        Dim nowStatus As Integer = GetInputMode()
        If nowStatus <> status Then
            Try
                subkey = Registry.CurrentUser.OpenSubKey(C_REG_SUBKEY, True)
                If subkey Is Nothing Then Return -1
                subkey.SetValue(C_REG_KEY, status)
            Catch ex As Exception
                Return -1
            Finally
                If subkey IsNot Nothing Then
                    subkey.Close()
                End If
            End Try
        End If
        Return nowStatus
    End Function

    Private Function GetInputMode() As Integer
        Dim subkey As RegistryKey = Nothing
        Try
            subkey = Registry.CurrentUser.OpenSubKey(C_REG_SUBKEY)
            If subkey Is Nothing Then Return -1
            Dim result As Object = subkey.GetValue(C_REG_KEY, Nothing)
            If result Is Nothing Then Return -1
            Return CType(result, Integer)
        Catch ex As Exception
            Return -1
        Finally
            If subkey IsNot Nothing Then
                subkey.Close()
            End If
        End Try
    End Function
End Class
